// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_ACURA_MOM_BACKEND/grmi"
	meta "LAPP_ACURA_MOM_BACKEND/meta/me"
	model "LAPP_ACURA_MOM_BACKEND/models/me"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : ProductFamilyRelateDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : ProductFamilyRelate的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-22 15:30:32
 *
 ******************************************************************************/
type ProductFamilyRelateDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewProductFamilyRelateDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个ProductFamilyRelateDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : ProductFamilyRelateDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-22 15:30:32
 *
 ******************************************************************************/
func NewProductFamilyRelateDAOImplement(session *xorm.Session, plantNr int, userid string) *ProductFamilyRelateDAOImplement {
	return &ProductFamilyRelateDAOImplement{session, &meta.ProductFamilyRelate, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductFamilyRelateDAO.InsertOne
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) InsertOne(entity *model.ProductFamilyRelate) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductFamilyRelateDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) DeleteOne(productFamilyId string, projectId string, productId string) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, productFamilyId, projectId, productId}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductFamilyRelateDAO.SelectOne
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) SelectOne(productFamilyId string, projectId string, productId string) (*model.ProductFamilyRelate, error) {
	var data model.ProductFamilyRelate
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, productFamilyId, projectId, productId}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductFamilyRelateDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) UpdateOne(entity *model.ProductFamilyRelate) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductFamilyRelateDAO.Insert
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) Insert(entities *[]model.ProductFamilyRelate) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductFamilyRelateDAO.Delete
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) Delete(entities *[]model.ProductFamilyRelate) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductFamilyRelateDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ProductFamilyRelate_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductFamilyRelateDAO.Select
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ProductFamilyRelate, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ProductFamilyRelate_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.ProductFamilyRelate_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.ProductFamilyRelate, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductFamilyRelateDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ProductFamilyRelate_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.ProductFamilyRelate_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			if orderBy == " order by " {
				orderBy += field.ColumnName
			} else {
				orderBy += ", " + field.ColumnName
			}
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.ProductFamilyRelate, 0, 10)
	where = " where " + where
	err = impl.session.Table(impl.meta.TableName).SQL("select * from ["+impl.meta.TableName+"]"+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductFamilyRelateDAO.Update
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) Update(entities *[]model.ProductFamilyRelate) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductFamilyRelateDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.ProductFamilyRelate, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ProductFamilyRelate_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.ProductFamilyRelate_LastUser.Name)
	entity.LastUser = impl.userid
	_, err := session.Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductFamilyRelateDAO.SelectProductByFamilyId
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) SelectProductByFamilyId(projectId string, familyId string) ([]model.Product, error) {
	result := make([]model.Product, 0, 4)
	parameters := []interface{}{impl.plantNr, projectId, familyId, true}
	where := fmt.Sprintf("%s = ? and %s = ? and %s = ? and %s = ?",
		meta.ProductFamilyRelate_PlantNr.ColumnName,
		meta.ProductFamilyRelate_ProjectId.ColumnName,
		meta.ProductFamilyRelate_ProductFamilyId.ColumnName,
		meta.Product_CreatePackOrderToggle.ColumnName)
	condition := fmt.Sprintf("%s = %s and %s = %s",
		meta.ProductFamilyRelate_PlantNr.ColumnName,
		meta.Product_PlantNr.ColumnName,
		meta.ProductFamilyRelate_ProductId.ColumnName,
		meta.Product_ProductId.ColumnName)
	err := impl.session.Table(impl.meta.TableName).Join("LEFT", meta.Product.TableName, condition).Where(where, parameters...).OrderBy(meta.ProductFamilyRelate_Pos.SortColumnName).Find(&result)
	return result, err
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductFamilyRelateDAO.SelectProductByFamilyId
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) SelectProductByFamilyIdForCreateSerialOrder(projectId string, familyId string) ([]model.Product, error) {
	result := make([]model.Product, 0, 4)
	parameters := []interface{}{impl.plantNr, projectId, familyId, true}
	where := fmt.Sprintf("%s = ? and %s = ? and %s = ? and %s = ?",
		meta.ProductFamilyRelate_PlantNr.ColumnName,
		meta.ProductFamilyRelate_ProjectId.ColumnName,
		meta.ProductFamilyRelate_ProductFamilyId.ColumnName,
		meta.Product_CreateWorkOrderToggle.ColumnName)
	condition := fmt.Sprintf("%s = %s and %s = %s",
		meta.ProductFamilyRelate_PlantNr.ColumnName,
		meta.Product_PlantNr.ColumnName,
		meta.ProductFamilyRelate_ProductId.ColumnName,
		meta.Product_ProductId.ColumnName)
	err := impl.session.Table(impl.meta.TableName).Join("LEFT", meta.Product.TableName, condition).Where(where, parameters...).OrderBy(meta.ProductFamilyRelate_Pos.SortColumnName).Find(&result)
	return result, err
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/jit/ProductFamilyRelateDAO.GetMaxPos
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) GetMaxPos(productFamilyId string) (int, error) {
	parameters := []interface{}{impl.plantNr, productFamilyId}
	where := fmt.Sprintf("%s = ? and %s = ?",
		meta.ProductFamilyRelate_PlantNr.ColumnName,
		meta.ProductFamilyRelate_ProductFamilyId.ColumnName,
		)
	var data model.ProductFamilyRelate
	ok, err := impl.session.Table(impl.meta.TableName).Where(where, parameters...).Desc(meta.ProductFamilyRelate_Pos.SortColumnName).Get(&data)
	if err != nil {
		return 0, err
	}
	if !ok {
		return 0, nil
	}
	return data.Pos, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/me/ProductFamilyRelateDAO.SelectProductByFamilyId
 *
 ******************************************************************************/
func (impl *ProductFamilyRelateDAOImplement) SelectPackProductByFamilyId(projectId string, familyId string) ([]model.Product, error) {
	result := make([]model.Product, 0, 4)
	parameters := []interface{}{impl.plantNr, projectId, familyId, true}
	where := fmt.Sprintf("%s = ? and %s = ? and %s = ? and %s = ?",
		meta.ProductFamilyRelate_PlantNr.ColumnName,
		meta.ProductFamilyRelate_ProjectId.ColumnName,
		meta.ProductFamilyRelate_ProductFamilyId.ColumnName,
		meta.Product_CreatePackOrderToggle.ColumnName)
	condition := fmt.Sprintf("%s = %s and %s = %s",
		meta.ProductFamilyRelate_PlantNr.ColumnName,
		meta.Product_PlantNr.ColumnName,
		meta.ProductFamilyRelate_ProductId.ColumnName,
		meta.Product_ProductId.ColumnName)
	err := impl.session.Table(impl.meta.TableName).Join("LEFT", meta.Product.TableName, condition).Where(where, parameters...).OrderBy(meta.ProductFamilyRelate_ProductId.SortColumnName).Find(&result)
	return result, err
}
